// SplineTesterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SplineTester.h"
#include "SplineTesterDlg.h"
#include "spline.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//two helper functions
void DrawCross(POINT point, COLORREF rgbColor, int extent, HDC hDC);
double Distance(const POINT& p1, const POINT& p2);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSplineTesterDlg dialog

CSplineTesterDlg::CSplineTesterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSplineTesterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSplineTesterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_MoveIndex = -1;
}

void CSplineTesterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSplineTesterDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSplineTesterDlg, CDialog)
	//{{AFX_MSG_MAP(CSplineTesterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSplineTesterDlg message handlers

BOOL CSplineTesterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSplineTesterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSplineTesterDlg::OnPaint() 
{

	CDialog::OnPaint();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSplineTesterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CSplineTesterDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//check if the mouse left clicking into one of the control points
	int index = IsInsideControlPoint(point);
	
	if(index >= 0)
	{
		//we are moving a control point around
		m_MoveIndex = index;
	}
	else //we are adding control points
	{
		CDC* pDC = GetDC();
		DrawCross(point, RGB(255,0,0), 4, pDC->m_hDC);
		m_ControlPoints.Add(point);
		if(m_ControlPoints.GetSize()>1)
		{
			//create a spline object
			Spline spline(m_ControlPoints.GetData(), m_ControlPoints.GetSize());
			//generate a curve
			spline.Generate();
			//get the curve points number
			m_CurvePoints.SetSize(spline.GetCurveCount());
			//get the points number
			int PointCount = 0;
			spline.GetCurve(m_CurvePoints.GetData(), PointCount);
			//paint the curve
			UpdateDialog(pDC->m_hDC);
		}
		ReleaseDC(pDC);
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CSplineTesterDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_MoveIndex >= 0)
	{
		m_ControlPoints[m_MoveIndex] = point;

		if(m_ControlPoints.GetSize()>1)
		{
			Spline spline(m_ControlPoints.GetData(), m_ControlPoints.GetSize());
			spline.Generate();
	
			m_CurvePoints.SetSize(spline.GetCurveCount());
			int PointCount = 0;
			spline.GetCurve(m_CurvePoints.GetData(), PointCount);
		}
		CDC* pDC = GetDC();
		UpdateDialog(pDC->m_hDC);
		ReleaseDC(pDC);
	}
	CDialog::OnMouseMove(nFlags, point);
}

void CSplineTesterDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_MoveIndex = -1;
	CDialog::OnLButtonUp(nFlags, point);
}
void CSplineTesterDlg::UpdateDialog(HDC& hDC)
{
	//brush the DC
	RECT rect;
	GetClientRect(&rect);
	FillRect(hDC, &rect, (HBRUSH)GetStockObject(LTGRAY_BRUSH));
	//draw the control points
	for(int i=0; i<m_ControlPoints.GetSize(); i++)
		DrawCross(m_ControlPoints[i], RGB(255,0,0), 4, hDC);
	//draw the curve
	if(m_CurvePoints.GetSize()>1)
		Polyline(hDC, m_CurvePoints.GetData(), m_CurvePoints.GetSize());
	
}

int CSplineTesterDlg::IsInsideControlPoint(POINT& point)
{
	int count = m_ControlPoints.GetSize();

	if(count>0)	
	{
		for(int i=0; i<count; i++)
		{
			if(Distance(m_ControlPoints[i], point)<5)
				return i;
		}
	}

	return -1;

}

double Distance(const POINT& p1, const POINT& p2)
{
	int dx = abs(p1.x - p2.x);
	int dy = abs(p1.y - p2.y);

	return sqrt(dx*dx + dy*dy);

}

void DrawCross(POINT point, COLORREF rgbColor, int extent, HDC hDC)
{

	HPEN hPen,oldPen;
	hPen = CreatePen(PS_SOLID,1,rgbColor);
    oldPen = (HPEN)SelectObject(hDC,hPen);
	
	MoveToEx(hDC,point.x - extent, point.y,NULL);
	LineTo(hDC, point.x + extent, point.y);
    
	MoveToEx(hDC, point.x, point.y - extent,NULL);
    LineTo(hDC,point.x, point.y + extent);
	SelectObject(hDC,oldPen);
	DeleteObject(hPen);

}